weka.filters.unsupervised.attribute

## Class NumericToDate

- java.lang.Object
- - weka.filters.Filter
  - - weka.filters.SimpleFilter
    - - weka.filters.SimpleBatchFilter
      - - weka.filters.unsupervised.attribute.NumericToDate

- All Implemented Interfaces:
    java.io.Serializable, CapabilitiesHandler, CapabilitiesIgnorer, CommandlineRunnable, OptionHandler, RevisionHandler, WeightedAttributesHandler, WeightedInstancesHandler

      public class NumericToDate
      extends SimpleBatchFilter
      implements WeightedAttributesHandler, WeightedInstancesHandler

  A filter for turning numeric attributes into date attributes. The numeric value is assumed to be the number of milliseconds since January 1, 1970, 00:00:00 GMT, corresponding to the given date."

  Valid options are:

       -R <col1,col2-col4,...>
        Specifies list of attributes to turn into date ones. Only numeric attributes will be converted.
        First and last are valid indexes.
        (default: first-last)

       -V
        Invert matching sense of column indexes.

       -F <value index>
        Sets the output date format string (default corresponds to ISO-8601).

  Version:
    $Revision: 14274 $
  Author:
    eibe (eibe at waikato dot ac dot nz)
  See Also:
    Serialized Form

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `NumericToDate()`

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `java.lang.String` | `attributeIndicesTipText()` Returns the tip text for this property
    `java.lang.String` | `dateFormatTipText()`
    `java.lang.String` | `getAttributeIndices()` Gets the current range selection
    `Capabilities` | `getCapabilities()` Returns the Capabilities of this filter.
    `java.text.SimpleDateFormat` | `getDateFormat()` Get the date format used in output.
    `boolean` | `getInvertSelection()` Gets whether the supplied columns are to be worked on or the others.
    `java.lang.String[]` | `getOptions()` Gets the current settings of the filter.
    `java.lang.String` | `getRevision()` Returns the revision string.
    `java.lang.String` | `globalInfo()` Returns a string describing this filter
    `java.lang.String` | `invertSelectionTipText()` Returns the tip text for this property
    `java.util.Enumeration<Option>` | `listOptions()` Gets an enumeration describing the available options.
    `static void` | `main(java.lang.String[] args)` Runs the filter with the given parameters.
    `void` | `setAttributeIndices(java.lang.String value)` Sets which attributes are to be turned into date attributes (only numeric attributes among the selection will be transformed).
    `void` | `setAttributeIndicesArray(int[] value)` Sets which attributes are to be transformed to date attributes (only numeric attributes among the selection will be transformed).
    `void` | `setDateFormat(java.text.SimpleDateFormat dateFormat)` Sets the output date format.
    `void` | `setDateFormat(java.lang.String dateFormat)` Sets the output date format.
    `void` | `setInvertSelection(boolean value)` Sets whether selected columns should be worked on or all the others apart from these.
    `void` | `setOptions(java.lang.String[] options)` Parses a given list of options.

    - ### Methods inherited from class weka.filters.SimpleBatchFilter

      `allowAccessToFullInputFormat, batchFinished, input, input`

    - ### Methods inherited from class weka.filters.SimpleFilter

      `setInputFormat`

    - ### Methods inherited from class weka.filters.Filter

      `batchFilterFile, debugTipText, doNotCheckCapabilitiesTipText, filterFile, getCapabilities, getCopyOfInputFormat, getDebug, getDoNotCheckCapabilities, getOutputFormat, isFirstBatchDone, isNewBatch, isOutputFormatDefined, makeCopies, makeCopy, mayRemoveInstanceAfterFirstBatchDone, numPendingOutput, output, outputPeek, postExecution, preExecution, run, runFilter, setDebug, setDoNotCheckCapabilities, toString, useFilter, wekaStaticWrapper`

    - ### Methods inherited from class java.lang.Object

      `equals, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- - ### Constructor Detail

    - #### NumericToDate

          public NumericToDate()

  - ### Method Detail

    - #### globalInfo

          public java.lang.String globalInfo()

      Returns a string describing this filter
      Specified by:
        `globalInfo` in class `SimpleFilter`
      Returns:
        a description of the filter suitable for displaying in the explorer/experimenter gui

    - #### listOptions

          public java.util.Enumeration<Option> listOptions()

      Gets an enumeration describing the available options.
      Specified by:
        `listOptions` in interface `OptionHandler`
      Overrides:
        `listOptions` in class `Filter`
      Returns:
        an enumeration of all the available options.

    - #### setOptions

          public void setOptions(java.lang.String[] options)
                          throws java.lang.Exception

      Parses a given list of options.

      Valid options are:

           -R <col1,col2-col4,...>
            Specifies list of attributes to turn into date ones. Only numeric attributes will be converted.
            First and last are valid indexes.
            (default: first-last)

           -V
            Invert matching sense of column indexes.

           -F <value index>
            Sets the output date format string (default corresponds to ISO-8601).

      Specified by:
        `setOptions` in interface `OptionHandler`
      Overrides:
        `setOptions` in class `Filter`
      Parameters:
        `options` - the list of options as an array of strings
      Throws:
        `java.lang.Exception` - if an option is not supported

    - #### getOptions

          public java.lang.String[] getOptions()

      Gets the current settings of the filter.
      Specified by:
        `getOptions` in interface `OptionHandler`
      Overrides:
        `getOptions` in class `Filter`
      Returns:
        an array of strings suitable for passing to setOptions

    - #### dateFormatTipText

          public java.lang.String dateFormatTipText()

      Returns:
        tip text for this property suitable for displaying in the explorer/experimenter gui

    - #### getDateFormat

          public java.text.SimpleDateFormat getDateFormat()

      Get the date format used in output.
      Returns:
        the output date format.

    - #### setDateFormat

          public void setDateFormat(java.lang.String dateFormat)

      Sets the output date format.
      Parameters:
        `dateFormat` - the output date format.

    - #### setDateFormat

          public void setDateFormat(java.text.SimpleDateFormat dateFormat)

      Sets the output date format.
      Parameters:
        `dateFormat` - the output date format.

    - #### invertSelectionTipText

          public java.lang.String invertSelectionTipText()

      Returns the tip text for this property
      Returns:
        tip text for this property suitable for displaying in the explorer/experimenter gui

    - #### getInvertSelection

          public boolean getInvertSelection()

      Gets whether the supplied columns are to be worked on or the others.
      Returns:
        true if the supplied columns will be worked on

    - #### setInvertSelection

          public void setInvertSelection(boolean value)

      Sets whether selected columns should be worked on or all the others apart from these. If true all the other columns are considered for conversion.
      Parameters:
        `value` - the new invert setting

    - #### attributeIndicesTipText

          public java.lang.String attributeIndicesTipText()

      Returns the tip text for this property
      Returns:
        tip text for this property suitable for displaying in the explorer/experimenter gui

    - #### getAttributeIndices

          public java.lang.String getAttributeIndices()

      Gets the current range selection
      Returns:
        a string containing a comma separated list of ranges

    - #### setAttributeIndices

          public void setAttributeIndices(java.lang.String value)

      Sets which attributes are to be turned into date attributes (only numeric attributes among the selection will be transformed).
      Parameters:
        `value` - a string representing the list of attributes. Since the string will typically come from a user, attributes are indexed from 1.
        eg: first-3,5,6-last
      Throws:
        `java.lang.IllegalArgumentException` - if an invalid range list is supplied

    - #### setAttributeIndicesArray

          public void setAttributeIndicesArray(int[] value)

      Sets which attributes are to be transformed to date attributes (only numeric attributes among the selection will be transformed).
      Parameters:
        `value` - an array containing indexes of attributes to turn into date ones. Since the array will typically come from a program, attributes are indexed from 0.
      Throws:
        `java.lang.IllegalArgumentException` - if an invalid set of ranges is supplied

    - #### getCapabilities

          public Capabilities getCapabilities()

      Returns the Capabilities of this filter.
      Specified by:
        `getCapabilities` in interface `CapabilitiesHandler`
      Overrides:
        `getCapabilities` in class `Filter`
      Returns:
        the capabilities of this object
      See Also:
        `Capabilities`

    - #### getRevision

          public java.lang.String getRevision()

      Returns the revision string.
      Specified by:
        `getRevision` in interface `RevisionHandler`
      Overrides:
        `getRevision` in class `Filter`
      Returns:
        the revision

    - #### main

          public static void main(java.lang.String[] args)

      Runs the filter with the given parameters. Use -h to list options.
      Parameters:
        `args` - the commandline options